# frozen_string_literal: true
require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

RSpec.describe ItemsController, type: :controller do
  # This should return the minimal set of attributes required to create a valid
  # Item. As you add validations to Item, be sure to
  # adjust the attributes here as well.
  let(:organization) { create(:organization) }
  let(:state) { create(:state) }
  let(:item_type) { create(:item_type, organization: organization, initial_state: state) }

  let(:item) do
    Item.create!(item_type: item_type, state: state, name: attributes_for(:item)[:name])
  end

  let(:invalid_attributes) do
    attributes_for(:item, name: nil)
  end

  # This should return the minimal set of values that should be in the session
  # in order to pass any filters (e.g. authentication) defined in
  # ItemsController. Be sure to keep this updated too.
  let(:valid_session) do
    { user_id: { 'uid' => create(:user).uid, 'extra' => { 'is_admin' => true } } }
  end

  describe 'GET #index' do
    it 'assigns all items as @items' do
      get :index, params: { organization_id: organization.to_param,
                            item_type_id: item_type.to_param }, session: valid_session
      expect(assigns(:items)).to eq([item])
    end
  end

  describe 'GET #show' do
    it 'assigns the requested item as @item' do
      get :show, params: { organization_id: organization.to_param, item_type_id: item_type.to_param,
                           id: item.to_param }, session: valid_session
      expect(assigns(:item)).to eq(item)
    end
  end

  describe 'GET #new' do
    it 'assigns a new item as @item' do
      get :new, params: { organization_id: organization.to_param,
                          item_type_id: item_type.to_param }, session: valid_session
      expect(assigns(:item)).to be_a_new(Item)
    end
  end

  describe 'GET #edit' do
    it 'assigns the requested item as @item' do
      get :edit, params: { organization_id: organization.to_param,
                           item_type_id: item_type.to_param, id: item.to_param },
                 session: valid_session
      expect(assigns(:item)).to eq(item)
    end
  end

  describe 'POST #create' do
    context 'with valid params' do
      it 'creates a new Item' do
        expect do
          post :create, params: { organization_id: organization.to_param,
                                  item_type_id: item_type.to_param, item: attributes_for(:item) },
                        session: valid_session
        end.to change(Item, :count).by(1)
      end

      it 'assigns a newly created item as @item' do
        post :create, params: { organization_id: organization.to_param,
                                item_type_id: item_type.to_param, item: attributes_for(:item) },
                      session: valid_session
        expect(assigns(:item)).to be_a(Item)
        expect(assigns(:item)).to be_persisted
      end

      it 'redirects to the created item' do
        post :create, params: { organization_id: organization.to_param,
                                item_type_id: item_type.to_param, item: attributes_for(:item) },
                      session: valid_session
        expect(response).to redirect_to([organization, item_type, Item.last])
      end
    end

    context 'with invalid params' do
      it 'assigns a newly created but unsaved item as @item' do
        post :create, params: { organization_id: organization.to_param,
                                item_type_id: item_type.to_param, item: invalid_attributes },
                      session: valid_session
        expect(assigns(:item)).to be_a_new(Item)
      end

      it "re-renders the 'new' template" do
        post :create, params: { organization_id: organization.to_param,
                                item_type_id: item_type.to_param, item: invalid_attributes },
                      session: valid_session
        expect(response).to render_template('new')
      end
    end
  end

  describe 'PUT #update' do
    context 'with valid params' do
      let(:new_attributes) do
        attributes_for(:item)
      end

      it 'updates the requested item' do
        put :update, params: { organization_id: organization.to_param,
                               item_type_id: item_type.to_param, id: item.to_param,
                               item: new_attributes },
                     session: valid_session
        item.reload
        expect(item.name).to eq(new_attributes[:name])
      end

      it 'assigns the requested item as @item' do
        put :update, params: { organization_id: organization.to_param,
                               item_type_id: item_type.to_param, id: item.to_param,
                               item: attributes_for(:item) },
                     session: valid_session
        expect(assigns(:item)).to eq(item)
      end

      it 'redirects to the item' do
        put :update, params: { organization_id: organization.to_param,
                               item_type_id: item_type.to_param, id: item.to_param,
                               item: attributes_for(:item) },
                     session: valid_session
        expect(response).to redirect_to([organization, item_type, item])
      end
    end

    context 'with invalid params' do
      it 'assigns the item as @item' do
        put :update, params: { organization_id: organization.to_param,
                               item_type_id: item_type.to_param, id: item.to_param,
                               item: invalid_attributes },
                     session: valid_session
        expect(assigns(:item)).to eq(item)
      end

      it "re-renders the 'edit' template" do
        put :update, params: { organization_id: organization.to_param,
                               item_type_id: item_type.to_param, id: item.to_param,
                               item: invalid_attributes }, session: valid_session
        expect(response).to render_template('edit')
      end
    end
  end

  describe 'DELETE #destroy' do
    before { item }

    before :each do
      request.env['HTTP_ACCEPT'] = 'application/json'
    end

    it 'destroys the requested item' do
      expect do
        delete :destroy, params: { organization_id: organization.to_param,
                                   item_type_id: item_type.to_param, id: item.to_param },
                         session: valid_session
      end.to change(Item, :count).by(-1)
    end

    it 'redirects to the items list' do
      delete :destroy, params: { organization_id: organization.to_param,
                                 item_type_id: item_type.to_param, id: item.to_param },
                       session: valid_session
      expect(response).to have_http_status(:no_content)
    end
  end
end
